package com.kwai.allin.demo;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.Signature;
import android.content.res.Configuration;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;


//import android.support.annotation.NonNull;
//import android.support.v4.app.FragmentActivity;
import androidx.annotation.NonNull;
import androidx.fragment.app.FragmentActivity;

import com.kwai.allin.demo.util.NotchUtils;
import com.kwai.middleware.azeroth.utils.DigestUtils;
import com.kwai.sdk.KwaiSdk;
import com.kwai.sdk.OnExitListener;

public class MainActivity extends FragmentActivity {

  private static final String TAG = "KwaiSdkDemo";

  //TODO Cp必须设置， 配置根据结果通知sdk
  @Override
  public void onConfigurationChanged(@NonNull Configuration newConfig) {
    KwaiSdk.onConfigurationChanged(this, newConfig);
    super.onConfigurationChanged(newConfig);
  }

  //TODO Cp必须设置，  权限申请结果通知sdk
  @Override
  public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions,
      @NonNull int[] grantResults) {
    KwaiSdk.onRequestPermissionsResult(this, requestCode, permissions, grantResults);
    super.onRequestPermissionsResult(requestCode, permissions, grantResults);
  }

  //TODO Cp必须设置，  结果通知sdk
  @Override
  protected void onActivityResult(int requestCode, int resultCode, @NonNull Intent data) {
    KwaiSdk.onActivityResult(this, requestCode, resultCode, data);
    super.onActivityResult(requestCode, resultCode, data);
  }

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main_activity);
    NotchUtils.fullScreen(this);
    getSupportFragmentManager().beginTransaction().replace(R.id.root_layout, new GameFragment())
        .commit();
    Log.e(TAG, " sgin :" + getSignature(getPackageName(), this));
    Log.e(TAG, " sdkinfo :" + KwaiSdk.getSdkInfo());
  }

  //TODO Cp必须设置， 新的intent根据结果通知sdk
  @Override
  protected void onNewIntent(Intent intent) {
    super.onNewIntent(intent);
    KwaiSdk.onNewIntent(this, intent);
  }

  /**
   * 返回键 监听
   * TODO 如果需要返回键可以关闭 sdk弹窗时，可以按下面处理， 不处理也不影响
   */
  @Override
  public boolean onKeyDown(int keyCode, KeyEvent event) {
    if (keyCode == KeyEvent.KEYCODE_BACK && KwaiSdk.onBackPressed()) {
      return true;
    }
    return super.onKeyDown(keyCode, event);
  }

  @Override
  public void onBackPressed() {
    KwaiSdk.exitApp(new OnExitListener() {
      @Override
      public void onExit() {
        finish();
      }

      @Override
      public void onCancel() {
      }

    });
  }

  public static String getSignature(String packageName, Context context) {
    if (TextUtils.isEmpty(packageName)) {
      return null;
    }
    try {
      Signature[] signatures = context.getPackageManager().getPackageInfo(packageName,
          PackageManager.GET_SIGNATURES).signatures;
      if (signatures == null || signatures.length == 0) {
        return null;
      } else {
        return DigestUtils.md5Hex(signatures[0].toByteArray());
      }
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    }
  }

  @Override
  public void onWindowFocusChanged(boolean hasFocus) {
    super.onWindowFocusChanged(hasFocus);
    NavigationBarStatusBar(this,hasFocus);
  }

  /**
   * 导航栏，状态栏隐藏
   * @param activity
   * TODO 全屏状态下隐藏通知栏 在cp接入的时候发现有些cp 使用windowManager addview的方式，显示界面，  有可能导致window的层级在 sdk智商
   * TODO 可能会导致 sdk弹窗显示不处理， 建议设置 FLAG  为TYPE_APPLICATION_PANEL  下面代码为隐藏导航栏和通知栏，如果需要可以使用
   */
  public static void NavigationBarStatusBar(Activity activity,boolean hasFocus){
    if (hasFocus && Build.VERSION.SDK_INT >= 19) {
      View decorView = activity.getWindow().getDecorView();
      decorView.setSystemUiVisibility(
          View.SYSTEM_UI_FLAG_LAYOUT_STABLE
              | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
              | View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN
              | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
              | View.SYSTEM_UI_FLAG_FULLSCREEN
              | View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY);
    }
  }
}
