package com.kwai.allin.demo;

import android.app.Application;
import android.content.res.Configuration;
import android.util.Log;

import com.kwai.allin.demo.test.AppInfoManager;
import com.kwai.sdk.KwaiSdk;
import com.kwai.sdk.KwaiSdkInitConfig;
import com.kwai.sdk.base.bean.KwaiAppInfo;
import com.kwai.sdk.combus.init.KwaiInitListener;
import com.kwai.sdk.combus.view.floatview.FloatViewInitLocation;


public class MyApplication extends Application {

  @Override
  public void onCreate() {
    super.onCreate();

    //TODO 注意  包名  签名 和appid需要匹配 不然后续登陆等功能会有问题

  KwaiAppInfo info = new KwaiAppInfo();
//    TODO AppId 必填  需要设置你们自己的AppId
    info.setAppId("ks685673047210945076");
    //TODO 应用名称
    info.setAppName("测试 Demo");
    //TODO 是否允许游客登陆
    info.setAllowTourist(false);
    //TODO 悬浮球位置，默认左上
    info.setFloatViewLocation(FloatViewInitLocation.LEFT_TOP);
    //TODO 是否使用sdk默认的隐私弹窗 如果用自己样式需要设置为false
    //info.setUseSdkPrivacyDialog(Boolean.parseBoolean(BuildConfig.USE_SDK_PRIVACY));

    Log.e("是否使用sdk默认的隐私弹窗",
        String.valueOf(Boolean.parseBoolean(BuildConfig.USE_SDK_PRIVACY)));
    KwaiSdkInitConfig config = new KwaiSdkInitConfig()
        .setApplication(this)
        .setAppInfo(info)
        .setInitListener(new KwaiInitListener() {

          @Override
          public void onSuccess(String channel) {

          }

          @Override
          public void onError(String msg) {

          }
        });
    KwaiSdk.init(config);
    AppInfoManager.getInstance().setAppId(info.getAppId());
    //TODO 最好设置，如果不是单独的activity 可以不设置，闪屏界面不申请权限或者做其他操作
    KwaiSdk.setSplashActivityName(SplashActivity.class.getName());
  }

  @Override
  public void onConfigurationChanged(Configuration newConfig) {
    super.onConfigurationChanged(newConfig);
  }
}
