package com.kwai.allin.demo;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
//import android.support.v4.app.FragmentActivity;
import androidx.fragment.app.FragmentActivity;
import android.util.Log;

import com.kwai.sdk.KwaiSdk;

public class SplashActivity extends FragmentActivity {
  private static final String TAG = "SplashActivity";
  Handler mHandler = new Handler(Looper.getMainLooper());

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_splash);
    if (checkPrivacyAgree()) {
      mHandler.postDelayed(new Runnable() {
        @Override
        public void run() {
          startActivity(new Intent(SplashActivity.this, MainActivity.class));
          overridePendingTransition(0, 0);
          SplashActivity.this.finish();
        }
      }, 3000);
      return;
    }
    Log.e(TAG,"Boolean.parseBoolean(BuildConfig.USE_SDK_PRIVACY) : " +
        ""+Boolean.parseBoolean(BuildConfig.USE_SDK_PRIVACY));

    //TODO cp接入时候，根据自己需求选择对应的分支， 是使用自己的隐私协议 还是sdk的隐私协议，如果使用自己的隐私协议，
    // 老版sdk：需要 sdk  在服务端配置中关闭自己的隐私
    // 新版sdk：需要在KwaiAppInfo 传入参数info.setUseSdkPrivacyDialog(false)
    // cp检查一下sdk中是否有该api，有该api则需要设置，没有则继续使用原来的配置下发即可
    if (checkPrivacyAgree() || Boolean.parseBoolean(BuildConfig.USE_SDK_PRIVACY)) {
      mHandler.postDelayed(new Runnable() {
        @Override
        public void run() {
          startActivity(new Intent(SplashActivity.this, MainActivity.class));
          overridePendingTransition(0, 0);
          SplashActivity.this.finish();
        }
      }, 3000);
      return;
    }
    usePrivacy();
  }

  private void usePrivacy() {
    AlertDialog.Builder builder = null;
    if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.LOLLIPOP_MR1) {
      builder =
          new AlertDialog.Builder(this,
              android.R.style.Theme_DeviceDefault_Light_Dialog_Alert);
    } else {
      builder =
          new AlertDialog.Builder(this,
              android.R.style.Theme_DeviceDefault_Light_Dialog);
    }
    builder.setTitle("隐私权保护政策");
    builder.setMessage("我是隐私协议的内容，是假的");
    builder.setPositiveButton("确认", new DialogInterface.OnClickListener() {
      @Override
      public void onClick(DialogInterface dialog, int which) {
        mHandler.postDelayed(new Runnable() {
          @Override
          public void run() {

            //TODO 必须设置，CP 如果使用自己的隐私协议， 这个值没有会出问题 最好在闪屏之后，游戏界面启动时候调用
            KwaiSdk.setPrivacyAgree();

            startActivity(new Intent(SplashActivity.this, MainActivity.class));
            overridePendingTransition(0, 0);
            SplashActivity.this.finish();
          }
        }, 300);
        dialog.dismiss();
      }
    });
    builder.setNegativeButton("取消", new DialogInterface.OnClickListener() {
      @Override
      public void onClick(DialogInterface dialog, int which) {
        finish();
      }
    });
    builder.show();
  }

  private boolean checkPrivacyAgree() {
    return KwaiSdk.isSdkPrivacyAgree();
  }
}