package com.kwai.allin.demo.ui;

import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.text.TextUtils;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.ScrollView;

public class DialogUtil {
  public static void getSelectFromDialog(Activity activity, String title, final String[] hints,final  String[] check ,  final ResultCallBack callBack) {
    ScrollView scrollView = new ScrollView(activity);
    final LinearLayout layout = new LinearLayout(activity);
    layout.setOrientation(LinearLayout.VERTICAL);
    layout.setBackgroundColor(Color.WHITE);
    scrollView.addView(layout);
    if (hints != null && hints.length > 0) {
      for (String hint : hints) {
        CheckBox et = new CheckBox(activity);
        et.setTextColor(Color.BLACK);
        et.setHint(hint);
        et.setTag(hint);
        if(check!=null){
          for (String s : check) {
            if(hint.equals(s)){
              et.setChecked(true);
            }
          }
        }
        layout.addView(et, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
      }
    }

    AlertDialog.Builder builder = null;
    if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.LOLLIPOP_MR1) {
      builder =
          new AlertDialog.Builder(activity,
              android.R.style.Theme_DeviceDefault_Light_Dialog_Alert);
    } else {
      builder =
          new AlertDialog.Builder(activity,
              android.R.style.Theme_DeviceDefault_Light_Dialog);
    }
    builder.setTitle(TextUtils.isEmpty(title) ? "请输入" : title);
    builder.setView(scrollView);
    builder.setPositiveButton("确认", new DialogInterface.OnClickListener() {
      @Override
      public void onClick(DialogInterface dialog, int which) {
        int count = layout.getChildCount();
        ArrayList<String> result = new ArrayList<String>();
        for (int i = 0; i < count; i++) {
          CheckBox checkBox = ((CheckBox) layout.getChildAt(i));
          if (checkBox.isChecked()) {
            result.add((String) checkBox.getTag());
          }
        }
        dialog.dismiss();
        if (callBack != null) {
          callBack.onResult(result.toArray(new String[0]));
        }

      }
    });
    builder.setNegativeButton("取消", null);
    builder.show();
  }
  public interface ResultCallBack {
    void onResult(String[] result);
  }
}
